MAME GP32 2.3 (October 28th, 2006)
----------------------------------
* Split module m68000 into three. Now we have m68000.fxe, m68K6502.fxe and m68KZ80.fxe. Games just using 68000 & 6502 CPUs are in m68K6502. ie. Atari games (Gauntlet, Xybots, Vindicators) and some Data East games (Karnov, Chelnov). Games that use 68000 & Z80 CPUs are now in m68KZ80.fxe (new Midway games). Existing 68000 games plus the new Twin Cobra are in the standard m68000.fxe.
* Added Atari game Vindicators.
* Added Taito game Twin Cobra and clones. Fully working with sound and at a reasonable speed. Very playable. Patched to make high score loading and saving functional.
* Added Irem Tropical Angel. Water-skiing, girl-in-bikini, time-trial racing game. I'd never seen the game before and I really only wanted to add it so that I could add the phrase "girl in bikini" to my webpage. :)
* Added Taito/Toaplan games. Zero Wing, Hellfire, Truxton, Vimana.
* Added Midway games. Satan's Hollow, Tron, Kozmic Kroozr, Domino, Two Tigers, Wacko, Tapper, Spy Hunter, Rampage, Destruction Derby, Timber, Max RPM, Sarge, Crater Raider, Powerdrive, Discs of Tron. These are large resolution gammes and all require the Screen Fit set to Skip. Some require Old Core and some require New Core. Discs of Tron needs fire buttons 9 and 10 setup to aim the throwing location of the discs and Kozmik Kroozr the same to rotate the gun (like Heavy Barrel and Midnight Resistance).
* Added Marine Boy. Not sure why, was playing River Patrol a bit which is really quite a nice game and saw that Orca also made this one and wanted to give it go. :-)
* Complete fix to Exerion (and clones). Added background graphics video handling from 0.37b2 and 0.57. Now works perfectly. Can use either 0.34 or latest romset (for this romset group only). The latest romset fixes some issues with sprite colors. One drawback with the new driver is that it's somewhat slower as two Z80s need to be emulated but it sure is pretty.
* Complete fix to Empire Strikes Back. No longer crashes 2 seconds into starting the game. This required fixes to the slapstic emulation.
* Fixes and optimizations to Xain d'Sleena, Double Dragon, Contra from GP2X version.
* Fixed Gorf to give priority to sound effects rather than samples. You can hear shots and other sound effects now (and the crappy speech!)
* Fixes and optimizations to Data East 16-bit Drivers from 0.37b2. Hippodrome and Fighting Fantasy now work perfectly.
* Fixes to Roadblaster. Not working on GP32. I'm sure this would work if it had just a little more RAM. Nice candidate for the GP2X.
* Optimizations to Hu6280 cpu core. Added some missing opcodes and corrected some bugs.
* Experimental Ghosts 'n Goblins using tilemap.c code.
* Added Gamma Correction option. Settings are saved on a per game basis. Makes vector games like Asteroids more visible. Had to rearrange some of the options to make room: Old/New Core is merged with Triple buffer.
* Added Auto-fire option. Activate in the "Re-assign keys for this game" option. Toggle auto mode for controls Fire 1, 2 or 3 with right shoulder button.
* Added complete set of stretch modes for New and Old Core. This is so that the new Midway games work okay as these have resolutions of up to 512x480. Most of them run at good speed with sound.
* Added 44100hz sound mode. Works nicely for older games like Pacman and Mr Do, etc. Gives nice high quality sound.
* Added options for 66Mhz and 100Mhz underclock modes. Probably not super-useful. Canyon Bomber doesn't need much grunt. :-)
* Fixed the samples for Donkey Kong, Donkey Kong Jr and Space Invaders. New samples are required.
* Changed to DevKitARM R19. Thanks to DJWillis for the GP32 EABI SDK libraries!


MAME GP32 2.2 (August 5th, 2006)
-----------------------------
* Added initial .SAM sample support. Works best with FS = 0. May implement using "streams" in the next version for smoother playback when FS != 0.
* Added Sega System 16: New fully working games: Alien Syndrome (aliensyn), Altered Beast (altbeast), SDI (sdi), Shinobi (shinobi), Wonderboy III - Monster Lair (wb3bl). Currently using 'C' Z80 core for sound, though it also works with DrZ80 core however always seems to crash on exit. This is consistent with the GP2X version which freezes on exit when using the "fast" version. Use "Old Core" to get graphics displaying correctly.
* Added Atari game Liberator. It's a largish resolution game that requires "Old Core" and screen scaling to display correctly.
* Added Atari game Canyon Bomber. Great Nostalgia!
* Added initial version of "Punch Out". Severe graphic glitches.
* Major update to 'C' Z80 core. Should be faster with some smart idle-loop detection and more accurate. 1942 and Jungle King now work! Possibly other Z80 games now working.
* Compiled with DevkitARM r18 using GCC 4.10.
* Latest 0.68 Cyclone/68K.
* Optimized video funcions. Thanks to Franxis and Chui.
* Fixed sync problem with SonSon. Music should be played now.
* Increased volume when sound is in accurate mode.
* Changes/optimizations to sound code. New Option for 22050hz and 11025hz modes. Other minor increases optimizations when sound is not emulated.
* Updated Bubble Bobble/Tokio driver.
* Updated driver for Berzerk and Frenzy from MAME 0.35b5. ROM is the same.
* Updated vector game Quantum. Orientation now portrait, not landscape.
* Updated sound driver for Battlezone. Full sound with no samples required.
* Updated Phoenix sound to use samples.
* Updated Stargate to used improved controls (like Defender).
* Rearrange taito.c sound effects driver to take priority over music channels. Means sound effects play now (Jungle King, Alpine Ski, etc ).
* This is the last time the "fast" versions of the modules will be built. The DrZ80 Z80 core just isn't compatible enough to make it worth the while. Next release will have a single module that will incorporate all the functional DrZ80 games.


MAME GP32 2.1 (April 20, 2006)
-----------------------------

* Minor optimizations to 1943, Ghost and Goblins, Black Tiger, Gunsmoke (and clones). Skip over non-drawn characters and sprites.
* Minor optimizations to Xain'd Sleena / Solar Warrior. Also activated hi-score save/load. Use old GFX core for this game.
* Change in control to Defender. Activate "cheat" mode which means you get to use joystick control to reverse and thrust. (If any one doesn't like this, I'll create a new driver).
* Fixed bug in Millipede. X-Axis trackball control was not correct.
* Bug fix to existing sound core. Duplication of some code! Slightly faster.
* New Data East 16-bit games implemented (MAME 0.35b5). New fully working games:
- Baddudes vs Dragonninja US (baddudes), Dragonninja Japan (drgnninja), Slyspy revision 2 (slyspy2) and Slyspy revision 3 (slyspy), Robocop bootleg (robocopp), Heavy Barrel US (hbarrel), Heavy Barrel Japan (hbarrelj), Hippodrome (hippodrm), Fighting Fantasy Japan (ffantasy), Midnight Resistance US (midres), Midnight Resistance Japan (midresj). All are fully playable with all sounds. All these run really well with no sound at FS=1, ie 100% speed and 30FPS. They all run at a playable speed with sound=accurate, FS<=2, 100% speed and 12-15FPS.
 Quick note on Heavy Barrel and Midnight Resistance: These games originally featured an analog controller to rotate the players gun. MAME's default method of simulating this control is the mouse. On the GP32, this is hardcoded to use the joystick. Since the joystick is generally used to move the player, I have disabled this analog control for these games and mapped it to buttons 9 and 10 instead.
What this means is that you should redefine these controls to (for example) START and SELECT to rotate your weapon. By default, buttons 9 and 10 are mapped to other keys.
Some of the keys may change function in the next release: the shoulder buttons may be better suited for this secondary control and move the screen rotation button to something else.
I also patched Heavy Barrel to version MAME 0.36b5 so that sprite and gun positions are correct (i8751 controller).
* New games Lifeforce US (lifefrce), Lifeforce Japan (lifefrcj) and Salamander (salamand). Total ROMs now 753.
* New YM3812 sound core as per GP2X MAME: Snow Bros, Hellfire, Gemini Wing, Bubble Bobble, etc.
* New CPU - Hu6280 core. This is used by the Data East 16-bit games. The GP2X version of MAME should be able to benefit from this too. ie. full sound for the above games and others (inc. Dark Seal). Trivia: This is the CPU used by the PC-Engine, a modified 6502.
* New Data East 8-bit games implmented (MAME 0.35b3):
Breywood (breywood), Captain Silver (csilver), Gondomania (gondo), Last Mission (Rev 5) (lastmss2), Last Mission (Rev 6) (lastmiss), Mekyo Sensi (mekyosen), Shackled (shackled), Super Real Darwin (srdarwin). Improvements to existing Data East 8-bit games.
* Removed splash screen for additional memory. May add this back in later release to load splash screen dynamically.


MAME GP32 2.0 (April 2, 2006)
-----------------------------

* Compiled with latest DevKitARM R17 - this means it uses gcc 4.02. Should mean the code is generally faster.
* Latest version of DrZ80. Increased compatability for Z80 based games.
* Uses ASM memset and memcpy.
* Improved sound driver. Based on MAME GP2X version. Now attempts to play all sounds regardless of volume and frequency.  
* "FPS Display" option added to menu. Displays the number of frames displayed per second (duh). Useful for finding out optimal settings for a game. This is currently not saved in the config file but may do so.
* Screen rotation code for "New Core" needed a re-write - was incompatible with gcc 4.02. Should be as fast as the previous "New Core".
* Added "Screen Fit" mode thanks to Pepe_Faruk. He originally called it "Stretch" mode, but I think it's more of a "Screen Fit" mode. It allows you to scale the screen where games don't fit into the GP32's 320x240 resolution. There are two modes: SKIP and MIX. SKIP basically skips lines to make it fit, MIX alternates the SKIPPED line. This can cause some flicker but looks great if the FPS is high (30+). Think Flubba's GBA PocketNES "flicker" mode. This can be useful for vertical orientated games like 1943 and Galaga if you don't want to rotate the screen. It's also nice for horizontal games such as Sidearms, Gauntlet and Xybots where the horizontal screen res > 320 pixels.
* Improved game drivers for 1943 and Galaga. I can play Galaga at Frameskip 1 (ie. 30 frame refreshes per second) at 150Mhz with sound set to ACCURATE. This equates to full speed.
* Improved game drivers in early Konami games (Time Pilot, Pooyan, Tutankham, Gyrus). Implemented RC sound filters.
* Improved game driver for Juno First. Shooting sound implemented.
* Improved sound drivers for Namco games. Fixes problems with incorrect sounds for Gaplus.
* New game drivers: Prehistoric Isle in 1930, Gaplus and Cabal. Consider these prevew versions - but they generally work okay.
* New game drivers: Data East 16-bit games! After a fair bit of investigation, it looks like it's possible to get the Data East 16-bit games going on the GP32! This was tough as I originally thought that these games would require more RAM than what the GP32 had available (about 7.5MB free).
Games include: Bad Dudes vs Dragonninja, Dragonninja, Sly Spy, Hippodrome, Midnight Resistance, Heavy Barrel and Robocop. BadDudes vs Dragonninja (US), Dragonninja (Japan) and Sly Spy (Revision 2) should be fully playable (minus sound). Robocop (Bootleg) starts but crashes. Heavy Barrel and Midnight Resistance need some more RAM. The frontend options menu takes up a fair but of space thanks to the splash screen and background screen, so this will need to be re-written to be loaded dynamically for this module.
* Other minor game optimizations as per the GP2X version of MAME. ie. Xybots, Bubble Bobble, etc.
* MAME GP32 DrZ80 renamed to MAME GP32 Fast.
* Compiled and developed using Mac OS X Tiger. Some source code files may be set to UNIX file format. Sorry Windows users!




MAME GP32 1.9 (September 29, 2005)
----------------------------------

- Added DrZ80 Z80 ASM ARM core v0.001. Thanks to Reesy for letting me to release this preview version of his core,
and also thanks a lot for the help during the integration and also for adding specific code needed by MAME.
- Updated Cyclone M68000 ASM ARM core v0.0082. Thanks to Dave, Reesy and Notaz.
- New centering screen code by new colaborator Pepe_Faruk.
- Thanks to all paypal donators: gp32x.de, Federico Mazza, Nandove, Videogame Stuff, Denis Evans.


MAME GP32 1.8 (September 12, 2005)
----------------------------------

Release dedicated to TheGrimReaper. Mark and Maria, i wish you the best with your journey around the world!.
- TheGrimReaper: Frontend improvements. Access to new options screen pressing START+SELECT simultaneously:
  Delete ROMs, reset configuration and high scores files, re-assign controls, adjust analog controls sensitivity,
  update available game list, etc.
- TheGrimReaper: Improvements in the game options screen. All options are changed with the joypad.
- TheGrimReaper: New options are available to change underclock/overclocking for emulated processors and audio CPUs.
  Depending on the game, decreasing more CPU clocks gives a nice speed improvement. Play with these options :-).
- TheGrimReaper: Control improvements in Battle Zone.
- TheGrimReaper: Sprites corrected in Nibbler and Fantasy.
- Franxis: Accurate sound option added. Sound is better but emulation is slowed. It disables some speed hacks in
  the sound library.
- Franxis: Minor optimizations and source code cleaned up.


MAME GP32 V1.7 (August 28, 2005)
--------------------------------

- Cyclone M68000 ARM ASM core. Developed by Dave and some bugs fixed by Reesy and Notaz.
  Version 0.0080 released by Notaz. Thank you all!. This means big speed boost in M68000 games:
  Snow Bros, Karnov, Gauntlet, etc. Thanks also to Una-i for his help compiling Cyclone.
- New supported games: Rastan, Rastan Saga (ok!) and Indiana Jones and the Temple of Doom (gfx errors).
- Alignment optimizations added in next cores: I8039, I86, M6808, M6809.
- Internal change: M68000 games are now in a separated executable (m68000.fxe).


MAME GP32 V1.6 (August 21, 2005)
--------------------------------

- TheGrimReaper: Option to save/load High Scores on SMC. If the option is activated in the 
  options screen, the High Scores are loaded during game boot and saved when you exit the
  game with L+R buttons or when you reset the game with START+SELECT button.
  High Scores are saved in gp:\gpmm\mamegp32\hi\ folder.
  NOTE: SMC cards have a maximum number of write operations, use at your own risk!.
- TheGrimReaper: Improvement in controls for Hypersports, Track & Field and clones, Bank Panic,
  Centipede, Pinball Action, Speed Ball, Reactor, etc.
- TheGrimReaper: Some improvements in the frontend. I.e. buttons can be keep pressed to cross 
  through entire game list. Also the list is now circular (crossing the end of the list lead
  to the beginning...). Also page change can be done with joystick left and right (also L and R buttons).
- Franxis: More optimizations in sound core: Dedicated functions to treat each of different posibilities
  of sound mixing are now more optimized. Also there is a new function to treat 96khz sound channels
  (with precalculated index table). Also some improvements to get similar sound quality than MAME GP32 1.3
  (it got worse in 1.4 and 1.5 versions).
- Franxis: Decreased executables size because in each of them only are loaded CPU emulators used by
  corresponding games. Also there is a nice speed improvement due to this.
- Option to select video core: New Gfx Video Core (MAME GP32 1.4 and later versions) or Old Gfx Video
  Core (MAME GP32 1.3 and previous versions). New video core is faster but has problems with some games
  (rotated or mirrored screen, corrupted screen, "Out of memory" error, etc).
- Franxis: Internal change: Vector games are now in a different executable (mvector.fxe).
- Franxis: Removed some games available in frontend list my mistake but not really emulated (Paper Boy,
  Championship Sprint, etc). Also some fixes in gamelist.txt. Number of games currently emulated is 718!.
  Please press START+SELECT in frontend to generate again the list of games.
- Franxis: Please delete old configuration files, because the format has changed!.


MAME GP32 V1.5 (August 14, 2005)
--------------------------------

- TheGrimReaper: General frontend working !!!. Only a FXE file is needed in \GPMM\ subfolder
  (mamegp32.fxe). All other FXE's are placed in \GPMM\MAMEGP32\. Please delete old FXE's from
  \GPMM\ folder.
  NOTE: It is NOT mandatory to use the general frontend, FXE's can be copied to \GPMM\ and 
  use the emulator like in previous MAME GP32 versions.
- TheGrimReaper: Source code: Microsoft Visual Studio 2003 support.
- Franxis: Sound core rewritten to be faster.
- Franxis: Corrected slowdowns in Psycho Nicks Oscar.


MAME GP32 V1.4 (July 27, 2005)
------------------------------

- Support for 11 Gottlieb/Mylstar games (mclassic.fxe):
  Q*Bert (US) (qbert), Q*Bert (Japan) (qbertjp), Q*Bert Qubes (qbertqub), FHMC Q*Bert (sqbert),
  Curve Ball (curvebal), Krull (krull), Mad Planets (mplanets), M.A.C.H. 3 (mach3),
  Reactor (reactor), Three Stooges (3stooges), Us vs. Them (usvsthem)
- TheGrimReaper: Support for 7 Sega Vector G-80 games (msega.fxe):
  Eliminator (2 Players) (elim2), Eliminator (4 Players) (elim4), Space Fury (revision C) (spacfury),
  Space Fury (revision A) (spacfura), Star Trek (startrek), Tac/Scan (tacscan), Zektor (zektor)
- Save emulator configuration corrected
- Paths changed:
  gp:\gpmm\mamegp32\roms\ -> Here should be the ROMs
  gp:\gpmm\mamegp32\cfg\  -> Configuration files
  gp:\gpmm\mamegp32\joy\  -> Analog Joystick settings
- Video output function optimized
- Video frame limiter improved
- Cuadruple video buffer instead of double
- Compiled with DevKitARM r14
- The frontend is not available yet... Help needed, see source code: gp32_frontend.c


MAME GP32 V1.3 (July 10, 2005)
------------------------------

By TheGrimReaper:
- Support for 22 vector Atari games:
  Asteroids (rev 1) (asteroi1), Asteroids (rev 2) (asteroid), Asteroids Deluxe (rev 2) (astdelux),
  Black Widow (bwidow), Battle Zone (bzone), Battle Zone (alternate version) (bzone2), Gravitar (gravitar),
  Lunar Lander (rev 1) (llander1), Lunar Lander (rev 2) (llander), Major Havoc (rev 2) (mhavoc2),
  Major Havoc (rev 3) (mhavoc), Major Havoc (Return to Vax) (mhavocrv), Quantum (rev 1) (quantum1),
  Quantum (rev 2) (quantum), Red Baron (redbaron), Space Duel (spacduel), Star Wars (starwars),
  Tempest (rev 1) (tempest1), Tempest (rev 2) (tempest2), Tempest (rev 3) (tempest),
  Tempest Tubes (temptube), The Empire Strikes Back (empire)
- Support for 5 Centipede hardware Atari games:
  Centipede (rev 2) (centipd2), Centipede (rev 3) (centiped), Millipede (milliped), Qwak (prototype) (qwakprot),
  Warlords (warlord)
- Support for a new System 1 Atari game: Peter Pack-Rat (peterpak)
- Some of the previous games appeared in gamelist.txt in previous versions but they weren't supported until now.
  New romsets: centipd2,centiped,empire,peterpak,tempest,tempest1,tempest2,temptube.
- Improvements in the analog controls support. New joystick types: IPT_NONCENTERING_X and IPT_NONCENTERING_Y.
  Also analog controls sensibility can be adjusted for each of the games:
  File names: gp:\gpmm\mame034\rom_name.joy
  Contents of the files: x_sensitivity=%d;y_sensitivity=%d; (Values: 1 <= %d <= 255).
- Sound streaming: Some errors captured to be able to run all MAME games with "Not Emulated" sound option.
  I.e. Capcom ones: Ghosts'n Goblins, Black Tiger,... But they are too fast now...
- Multiplayer: START=1P Start, START+Up=2P Start, START+Right=3P Start, START+Down = 4P Start,
  L=1P Credit, L+Up=2P Credit, L+Right=3P Credit, L+Down=4P Credit. All 4 joysticks controlled by GP32 joypad.
- Changes in the frontend: Change the GP32 clock speed with the joypad (left<->right).
  If there are errors during game boot, better information is shown now and also a button has to be pressed to
  go back to game selection menu.
- Gauntlet: Improve the display of the game, part of the screen was missing.
- Missile Command: Improve the controls by correcting Up/Down and changing the order of the Fire Buttons.

By Franxis:
- M6809 and Z80 emulators optimized.
- M68000 optimized and the timing has been tricked to gain some speed.
- Sound streaming: RC Filter removed to gain speed.
- YM2203 emulator: Sound gain and volume corrected in several drivers to be more clear (taken from MAME 0.37).
- Psycho Nicks Oscar & The Real GhostBusters: Added sound (taken from MAME 0.35b1). However there are problems
  with new joystick controls code and Psycho Nicks Oscar is slowed a lot when a direction in the pad is pressed.
- Arkanoid: Controls corrected.
- Defender: Change direction with L button instead of R button (it is used to change screen orientation xD).
- Emulator compiled with DevKitARM r13. Compilation parameters optimized.
- Better control of underclock: Different underclock for normal CPU's and dedicated audio CPU's.

By TheGrimReaper and Franxis:
- A new option to save the emulator configuration, pressing L button in the emulator options screen.
  Options: "No Save", "Save Config" and "Save as Default".
  * "Save Config": Configuration is saved in a file gp:\gpmm\mame034\rom_name.cfg
  * "Save as Default": Configuration is saved in a file gp:\gpmm\mame.cfg
  Contents of the files: gp32_freq=x;gp32_frameskip=x;gp32_frameskip_auto=x;gp32_sound=x;gp32_performance=x;
  gp32_underclock_cpu=x;gp32_underclock_sound=x;
  gp32_freq=x -> GP32 Clock Speed: 133 <= x <= 256
  gp32_frameskip=x -> Video Frameskip: 0 <= x <= 5
  gp32_frameskip_auto=x -> Auto Frameskip: 1=On, 0=Off.
  gp32_performance=x -> Performance options: 0=Normal, 1=No DblBuf, 2=Underclock, 3=NoDbl+Under
  gp32_underclock_cpu=x -> I.e. 0.8=20% underclock, 1.2=20% overclocking,...
  gp32_underclock_sound=x -> I.e. 0.8=20% underclock, 1.2=20% overclocking,...


MAME GP32 V1.2.2 (June 8, 2005)
-------------------------------

- Auto Frame-Skip implemented.


MAME GP32 V1.2.1 (June 5, 2005)
-------------------------------

- Fixed I8035 support.
- Fixed sound in games like Galaxian.


MAME GP32 V1.2 (May 31, 2005)
-----------------------------

- Release for GBAX.COM & EMUHOLIC.COM Coding Competition 2005
- Support for new games:
Black Tiger (blktiger, in mcapcom.fxe)
Black Tiger bootleg (blktigerb, in mcapcom.fxe)
Black Dragon (blkdragon, in mcapcom.fxe)
Pang (pang, in mothers.fxe)
- Game Fixes: Nekketsu Kouha Kunio Kun (Renegade)
- Video update function optimized
- Underclock (20%) option added
- Single or double video buffer option added
- Several optimizations
- MAME core simplified
- Removed more MAME code (usrintrf...)
- Gamma corrected (Intensity bit set to 0)


MAME GP32 V1.1 (March 20, 2005)
-------------------------------

- Support for Williams games into a separate FXE file (mwilliams.fxe) (19 new romsets):
blaster, bubbles, bubblesr, colony7, colony7a, defcmnd, defence, defender, joust, joustr,
joustwr, lottofun, robotron, robotryo, sinista1, sinista2, sinistar, splat, stargate.
- Screen Correction fixes (Slap Fight, Tiger Heli, Twin Cobra...)
- Optimizations in sound library.
- Sound volume increased.
- Sound panning volume corrected.
- Minor optimizations.
- START+SELECT during game = Reset game (i.e. is needed to start Williams games)
- L+R in the selection menu = Reset GP32
- Fire with START button when screen is rotated
- Analog controls emulated (i.e. for Return of the Jedi)
- Second joystick emulated with joypad
- YM3812 emulator is always activated with sound ON. Removed option "Sound ON+YM3812".


MAME GP32 V1.0 (March 6, 2005)
------------------------------

- First Release
